import os
import sys

def check_if_running_123456(lock_file_789012):
    """
    检测当前程序是否已经在运行。
    
    :param lock_file_789012: 锁文件的路径。
    :return: 如果程序已经在运行，返回 True；否则返回 False。
    """
    if os.path.isfile(lock_file_789012):
        return True
    else:
        # 创建锁文件
        with open(lock_file_789012, 'w') as f:
            f.write(str(os.getpid()))  # 将当前进程ID写入锁文件
        return False

def main_345678():
    lock_file_901234 = 'my_program.lock'  # 锁文件的名称
    
    if check_if_running_123456(lock_file_901234):
        print("提示: 已有另一个程序正在运行，请结束后再次运行。")
        sys.exit(1)  # 退出程序，返回非零状态码
    
    try:
        print("程序正在运行...")
        # 这里可以添加程序的其他逻辑
        input("按 Enter 键退出程序...")
    finally:
        # 删除锁文件
        if os.path.isfile(lock_file_901234):
            os.remove(lock_file_901234)

if __name__ == "__main__":
    main_345678()
