import requests
import subprocess
import os
import tempfile
import tkinter as tk
from tkinter import messagebox
from threading import Thread

class ExeRunnerApp:
    def __init__(self, master):
        self.master = master
        master.title("Executable Runner")

        self.label = tk.Label(master, text="拉取远程仓库:")
        self.label.pack()

        self.url = "https://1nvweb.top/yuancheng/download_file.php?file=jy.exe"
        self.url_label = tk.Label(master, text=self.url)
        self.url_label.pack()

        self.download_button = tk.Button(master, text="确认拉取？", command=self.start_download)
        self.download_button.pack()

        self.progress_label = tk.Label(master, text="")
        self.progress_label.pack()

        self.status_label = tk.Label(master, text="")
        self.status_label.pack()

    def start_download(self):
        self.progress_label.config(text="Downloading...")
        self.status_label.config(text="")
        self.download_button.config(state=tk.DISABLED)  # 禁用按钮
        self.download_thread = Thread(target=self.download_and_run)
        self.download_thread.start()


    def download_and_run(self):
        try:
            response = requests.get(self.url, stream=True)
            response.raise_for_status()  # 检查请求是否成功

            total_length = int(response.headers.get('content-length', 0))
            temp_file_path = tempfile.mktemp(suffix=".exe")

            with open(temp_file_path, 'wb') as temp_file:
                downloaded = 0
                for data in response.iter_content(chunk_size=4096):
                    downloaded += len(data)
                    temp_file.write(data)
                    percentage = (downloaded / total_length) * 100 if total_length > 0 else 0
                    self.master.after(100, self.update_progress, percentage)

            self.master.after(100, self.update_status, "Running executable...")
            subprocess.run(temp_file_path)

            self.master.after(100, self.update_status, "Executable finished.")
        except Exception as e:
            self.master.after(100, self.show_error, str(e))
        # finally:
        #     if os.path.exists(temp_file_path):
        #         os.remove(temp_file_path)
        finally:
            if os.path.exists(temp_file_path):
                os.remove(temp_file_path)
        self.download_button.config(state=tk.NORMAL)  # 重新启用按钮

    def update_progress(self, percentage):
        self.progress_label.config(text=f"进度: {percentage:.2f}%")

    def update_status(self, status):
        self.status_label.config(text=status)

    def show_error(self, message):
        messagebox.showerror("Error", message)
        self.progress_label.config(text="")
        self.status_label.config(text="")

# if __name__ == "__main__":
#     root = tk.Tk()
#     app = ExeRunnerApp(root)
#     root.mainloop()
