# import socket
# import threading
# import time
# import sys

# # 扫描端口的函数
# def scan_port(ip, port, interval):
#     try:
#         with socket.socket(socket.AF_INET, socket.SOCK_STREAM) as sock:
#             sock.settimeout(1)
#             result = sock.connect_ex((ip, port))
#             if result == 0:
#                 print(f"端口 {port} 是开放的")
#             else:
#                 print(f"端口 {port} 是关闭的")
#     except Exception as e:
#         print(f"无法扫描端口 {port}: {e}")
#     time.sleep(interval)

# # 扫描函数，创建线程
# def port_scanner(ip, start_port, end_port, interval, max_threads):
#     threads_list = []
    
#     # 用于控制活动线程数的锁
#     lock = threading.Lock()
    
#     def thread_worker(port):
#         scan_port(ip, port, interval)
#         with lock:
#             threads_list.remove(threading.current_thread())

#     for port in range(start_port, end_port + 1):
#         while len(threads_list) >= max_threads:
#             time.sleep(0.1)

#         thread = threading.Thread(target=thread_worker, args=(port,))
#         threads_list.append(thread)
#         thread.start()

#     # 等待所有线程完成
#     for thread in threads_list:
#         thread.join()

# # 主函数
# def main():
#     ip = input("请输入 IP 地址或域名: ")
#     start_port = int(input("请输入起始端口: "))
#     end_port = int(input("请输入结束端口: "))
#     interval = float(input("请输入扫描间隔（秒）: "))
#     max_threads = int(input("请输入最大线程数: "))

#     print("开始扫描...")
    
#     try:
#         port_scanner(ip, start_port, end_port, interval, max_threads)
#     except KeyboardInterrupt:
#         print("\n扫描被用户中止")
#         sys.exit(0)

# if __name__ == "__main__":
#     main()

# import socket
# import threading
# import time
# import sys
# import tkinter as tk

# # 扫描端口的函数
# def scan_port(ip, port, interval, results):
#     try:
#         with socket.socket(socket.AF_INET, socket.SOCK_STREAM) as sock:
#             sock.settimeout(1)
#             result = sock.connect_ex((ip, port))
#             if result == 0:
#                 print(f"端口 {port} 是开放的")  # CMD输出
#                 results.append(port)  # 添加到结果列表
#             else:
#                 print(f"端口 {port} 是关闭的")  # CMD输出
#     except Exception as e:
#         print(f"无法扫描端口 {port}: {e}")
#     time.sleep(interval)

# # 扫描函数，创建线程
# def port_scanner(ip, start_port, end_port, interval, max_threads, results):
#     threads_list = []
#     lock = threading.Lock()

#     def thread_worker(port):
#         scan_port(ip, port, interval, results)
#         with lock:
#             threads_list.remove(threading.current_thread())

#     for port in range(start_port, end_port + 1):
#         while len(threads_list) >= max_threads:
#             time.sleep(0.1)

#         thread = threading.Thread(target=thread_worker, args=(port,))
#         threads_list.append(thread)
#         thread.start()

#     for thread in threads_list:
#         thread.join()

# # 显示结果的GUI
# def show_results(results):
#     result_window = tk.Tk()
#     result_window.title("开放端口扫描结果")

#     if results:
#         result_text = "\n".join(f"端口 {port} 是开放的" for port in results)
#     else:
#         result_text = "没有开放的端口。"

#     label = tk.Label(result_window, text=result_text, padx=20, pady=20)
#     label.pack()

#     button = tk.Button(result_window, text="关闭", command=result_window.destroy)
#     button.pack(pady=(0, 20))

#     result_window.mainloop()

# # 主函数
# def main_port():
#     ip = input("请输入 IP 地址或域名: ")
#     start_port = int(input("请输入起始端口: "))
#     end_port = int(input("请输入结束端口: "))
#     interval = float(input("请输入扫描间隔（秒）: "))
#     max_threads = int(input("请输入最大线程数: "))

#     print("开始扫描...")
#     results = []

#     try:
#         port_scanner(ip, start_port, end_port, interval, max_threads, results)
#         show_results(results)  # 扫描完成后显示结果
#     except KeyboardInterrupt:
#         print("\n扫描被用户中止")
#         sys.exit(0)


import socket
import threading
import time
import sys
import tkinter as tk

# 扫描端口的函数
def scan_port(ip, port, interval, results):
    try:
        with socket.socket(socket.AF_INET, socket.SOCK_STREAM) as sock:
            sock.settimeout(1)
            result = sock.connect_ex((ip, port))
            if result == 0:
                print(f"端口 {port} 是开放的")  # CMD输出
                results.append(port)  # 添加到结果列表
            else:
                print(f"端口 {port} 是关闭的")  # CMD输出
    except Exception as e:
        print(f"无法扫描端口 {port}: {e}")
    time.sleep(interval)

# 扫描函数，创建线程
def port_scanner(ip, start_port, end_port, interval, max_threads, results):
    threads_list = []
    lock = threading.Lock()

    def thread_worker(port):
        scan_port(ip, port, interval, results)
        with lock:
            threads_list.remove(threading.current_thread())

    for port in range(start_port, end_port + 1):
        while len(threads_list) >= max_threads:
            time.sleep(0.1)

        thread = threading.Thread(target=thread_worker, args=(port,))
        threads_list.append(thread)
        thread.start()

    for thread in threads_list:
        thread.join()

# 显示结果的GUI
def show_results(results):
    result_window = tk.Tk()
    result_window.title("开放端口扫描结果")

    if results:
        result_text = "\n".join(f"端口 {port} 是开放的" for port in results)
    else:
        result_text = "没有开放的端口。"

    label = tk.Label(result_window, text=result_text, padx=20, pady=20)
    label.pack()

    button = tk.Button(result_window, text="关闭", command=result_window.destroy)
    button.pack(pady=(0, 20))

    result_window.mainloop()

# 主函数
def main_port():
    ip = input("请输入 IP 地址或域名: ")
    
    while True:
        try:
            start_port = int(input("请输入起始端口: "))
            end_port = int(input("请输入结束端口: "))
            interval = float(input("请输入扫描间隔（秒）: "))
            max_threads = int(input("请输入最大线程数: "))
            break  # 输入合法，退出循环
        except ValueError:
            print("输入错误，请确保输入的是数字。")

    print("开始扫描...")
    results = []

    try:
        port_scanner(ip, start_port, end_port, interval, max_threads, results)
        show_results(results)  # 扫描完成后显示结果
    except KeyboardInterrupt:
        print("\n扫描被用户中止")
        sys.exit(0)

if __name__ == "__main__":
    main_port()
