# import requests
# import time
# import os

# def path_brute_force(base_url, wordlist_file, requests_per_second):
#     with open(wordlist_file, 'r', encoding='utf-8') as file:
#         paths = file.readlines()

#     # 计算请求间隔时间
#     interval = 1.0 / requests_per_second
#     total_paths = len(paths)  # 获取路径总数

#     for index, path in enumerate(paths):
#         path = path.strip()  # 移除空格和换行符
#         url = f"{base_url}/{path}"  # 生成完整URL
#         try:
#             response = requests.get(url)

#             # 检查响应状态码
#             if response.status_code == 200:
#                 print(f"[+] 找到: {url}")
#             elif response.status_code == 403:
#                 print(f"[+] 禁止访问: {url}")
#             elif response.status_code == 404:
#                 print(f"[-] 未找到: {url}")
#             else:
#                 print(f"[?] 状态 {response.status_code}: {url}")

#             # 输出进度
#             progress = (index + 1) / total_paths * 100
#             print(f"进度: {progress:.2f}% ({index + 1}/{total_paths})")

#             # 等待一段时间以控制请求频率
#             time.sleep(interval)

#         except requests.exceptions.RequestException as e:
#             print(f"[!] 错误: {e}")

# def get_input(prompt, input_type=str, error_message="无效输入。请再试一次。"):
#     while True:
#         try:
#             user_input = input_type(input(prompt))
#             return user_input
#         except ValueError:
#             print(error_message)

# def get_valid_file_path(prompt):
#     while True:
#         file_path = input(prompt)
#         if os.path.isfile(file_path):  # 检查文件是否存在
#             return file_path
#         else:
#             print("文件未找到。请输入有效的文件路径。")

# if __name__ == "__main__":
#     target_url = get_input("输入基础URL（例如，http://example.com）：")
#     wordlist = get_valid_file_path("输入字典文件路径（例如，path_dict.txt）：")
#     requests_per_second = get_input("输入每秒请求数（例如，5）：", float)

#     path_brute_force(target_url, wordlist, requests_per_second)
# import requests
# import time
# import os
# import threading
# from queue import Queue

# def worker(queue, requests_per_second):
#     while not queue.empty():
#         path = queue.get()
#         url = path.strip()
#         try:
#             response = requests.get(url)

#             # 检查响应状态码
#             if response.status_code == 200:
#                 print(f"[+] 找到: {url}")
#             elif response.status_code == 403:
#                 print(f"[+] 禁止访问: {url}")
#             elif response.status_code == 404:
#                 print(f"[-] 未找到: {url}")
#             else:
#                 print(f"[?] 状态 {response.status_code}: {url}")

#         except requests.exceptions.RequestException as e:
#             print(f"[!] 错误: {e}")

#         time.sleep(1.0 / requests_per_second)  # 控制请求频率
#         queue.task_done()

# def path_brute_force(base_url, wordlist_file, requests_per_second, num_threads):
#     with open(wordlist_file, 'r', encoding='utf-8') as file:
#         paths = file.readlines()

#     queue = Queue()
    
#     # 将所有路径放入队列中
#     for path in paths:
#         queue.put(f"{base_url}/{path.strip()}")

#     threads = []
    
#     # 创建并启动线程
#     for _ in range(num_threads):
#         thread = threading.Thread(target=worker, args=(queue, requests_per_second))
#         thread.start()
#         threads.append(thread)

#     # 等待队列完成
#     queue.join()

#     # 等待所有线程结束
#     for thread in threads:
#         thread.join()

# def get_input(prompt, input_type=str, error_message="无效输入。请再试一次。"):
#     while True:
#         try:
#             user_input = input_type(input(prompt))
#             return user_input
#         except ValueError:
#             print(error_message)

# def get_valid_file_path(prompt):
#     while True:
#         file_path = input(prompt)
#         if os.path.isfile(file_path):  # 检查文件是否存在
#             return file_path
#         else:
#             print("文件未找到。请输入有效的文件路径。")

# if __name__ == "__main__":
#     target_url = get_input("输入基础URL（例如，http://example.com）：")
#     wordlist = get_valid_file_path("输入字典文件路径（例如，path_dict.txt）：")
#     requests_per_second = get_input("输入每秒请求数（例如，5）：", float)
#     num_threads = get_input("输入线程数（例如，5）：", int)

#     path_brute_force(target_url, wordlist, requests_per_second, num_threads)
# import requests
# import time
# import os
# import threading
# from queue import Queue

# def worker(queue, requests_per_second, results):
#     while not queue.empty():
#         path = queue.get()
#         url = path.strip()
#         try:
#             response = requests.get(url)

#             # 检查响应状态码
#             if response.status_code == 200:
#                 results.append(url)  # 将找到的URL添加到结果列表
#                 print(f"[+] 找到: {url}")
#             elif response.status_code == 403:
#                 print(f"[+] 禁止访问: {url}")
#             elif response.status_code == 404:
#                 print(f"[-] 未找到: {url}")
#             else:
#                 print(f"[?] 状态 {response.status_code}: {url}")

#         except requests.exceptions.RequestException as e:
#             print(f"[!] 错误: {e}")

#         time.sleep(1.0 / requests_per_second)  # 控制请求频率
#         queue.task_done()

# def path_brute_force(base_url, wordlist_file, requests_per_second, num_threads):
#     with open(wordlist_file, 'r', encoding='utf-8') as file:
#         paths = file.readlines()

#     queue = Queue()
#     results = []  # 用于存储找到的有效路径

#     # 将所有路径放入队列中
#     for path in paths:
#         queue.put(f"{base_url}/{path.strip()}")

#     threads = []
    
#     # 创建并启动线程
#     for _ in range(num_threads):
#         thread = threading.Thread(target=worker, args=(queue, requests_per_second, results))
#         thread.start()
#         threads.append(thread)

#     # 等待队列完成
#     queue.join()

#     # 等待所有线程结束
#     for thread in threads:
#         thread.join()

#     return results  # 返回找到的结果列表

# def get_input(prompt, input_type=str, error_message="无效输入。请再试一次。"):
#     while True:
#         try:
#             user_input = input_type(input(prompt))
#             return user_input
#         except ValueError:
#             print(error_message)

# def get_valid_file_path(prompt):
#     while True:
#         file_path = input(prompt)
#         if os.path.isfile(file_path):  # 检查文件是否存在
#             return file_path
#         else:
#             print("文件未找到。请输入有效的文件路径。")

# if __name__ == "__main__":
#     target_url = get_input("输入基础URL（例如，http://example.com）：")
#     wordlist = get_valid_file_path("输入字典文件路径（例如，path_dict.txt）：")
#     requests_per_second = get_input("输入每秒请求数（例如，5）：", float)
#     num_threads = get_input("输入线程数（例如，5）：", int)

#     found_paths = path_brute_force(target_url, wordlist, requests_per_second, num_threads)

#     # 输出扫描结果
#     print("\n扫描完成！")
#     print(f"找到的有效路径总数: {len(found_paths)}")
#     if found_paths:
#         print("找到的路径：")
#         for path in found_paths:
#             print(path)

import requests
import time
import os
import threading
from queue import Queue
from urllib.parse import urljoin

import requests
import threading
import time
from queue import Queue
import os
from urllib.parse import urljoin

def worker(queue, requests_per_second, results):
    """从队列中获取URL，进行请求并记录有效路径。"""
    while not queue.empty():
        url = queue.get()
        try:
            response = requests.get(url)

            # 检查响应状态码
            if response.status_code == 200:
                results.append(url)  # 将找到的URL添加到结果列表
                print(f"[+] 找到: {url}")
            elif response.status_code == 403:
                print(f"[+] 禁止访问: {url}")
            elif response.status_code == 404:
                print(f"[-] 未找到: {url}")
            else:
                print(f"[?] 状态 {response.status_code}: {url}")

        except requests.exceptions.RequestException as e:
            print(f"[!] 错误: {e}")

        time.sleep(1.0 / requests_per_second)  # 控制请求频率
        queue.task_done()

def path_brute_force(base_url, wordlist_file, requests_per_second, num_threads):
    """从字典文件中读取路径，使用多个线程进行暴力破解。"""
    with open(wordlist_file, 'r', encoding='utf-8') as file:
        paths = file.readlines()

    queue = Queue()
    results = []  # 用于存储找到的有效路径

    # 将所有路径放入队列中
    for path in paths:
        url = urljoin(base_url, path.strip())  # 安全拼接URL
        queue.put(url)

    threads = []
    
    # 创建并启动线程
    for _ in range(num_threads):
        thread = threading.Thread(target=worker, args=(queue, requests_per_second, results))
        thread.start()
        threads.append(thread)

    # 等待队列完成
    queue.join()

    # 等待所有线程结束
    for thread in threads:
        thread.join()

    return results  # 返回找到的结果列表

def get_input(prompt, input_type=str, error_message="无效输入。请再试一次。"):
    """获取用户输入并进行类型检查。"""
    while True:
        user_input = input(prompt)
        if user_input.lower() == "exit":
            print("退出程序。")
            return None  # 返回 None 表示退出循环
        try:
            return input_type(user_input)
        except ValueError:
            print(error_message)

def get_valid_file_path(prompt):
    """获取用户输入的有效文件路径。"""
    while True:
        file_path = input(prompt)
        if os.path.isfile(file_path):  # 检查文件是否存在
            return file_path
        else:
            print("文件未找到。请输入有效的文件路径。")

def main_lujingbaopo():
    """主程序入口。"""
    target_url = get_input("输入URL（例如，http://example.com (exit退出)）：")
    if target_url is None:
        return  # 如果返回 None，退出主程序
    wordlist = get_valid_file_path("输入字典文件路径（绝对路径）：")
    if wordlist is None:
        return  # 如果返回 None，退出主程序
    requests_per_second = get_input("输入每秒请求数（例如，5）：", float)
    num_threads = get_input("输入线程数（例如，5）：", int)

    found_paths = path_brute_force(target_url, wordlist, requests_per_second, num_threads)

    # 输出扫描结果
    print("\n扫描完成！")
    print(f"找到的有效路径总数: {len(found_paths)}")
    if found_paths:
        print("找到的路径：")
        for path in found_paths:
            print(path)

if __name__ == "__main__":
    main_lujingbaopo()
