import os
import platform
import subprocess
import threading
import time
import sys

# def ping(host, packet_size, count, timeout):
#     """执行 ping 命令，并输出结果"""
#     for i in range(count):
#         try:
#             # 根据操作系统选择相应的 ping 命令
#             command = (
#                 ['ping', '-c', '1', '-s', str(packet_size), '-W', str(timeout), host] 
#                 if platform.system().lower() != 'windows' 
#                 else ['ping', '-n', '1', '-l', str(packet_size), '-w', str(timeout * 1000), host]
#             )
#             output = subprocess.run(command, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
#             print(f"Ping {host}：{output.stdout.decode(errors='ignore').strip() if output.returncode == 0 else output.stderr.decode(errors='ignore').strip()}")
#         except Exception as e:
#             print(f"错误: {e}")
#         time.sleep(1)  # 添加延时以避免网络过载
def ping(host, packet_size, count, timeout):
    for i in range(count):
        try:
            command = (
                ['ping', '-c', '1', '-s', str(packet_size), '-W', str(timeout), host] 
                if platform.system().lower() != 'windows' 
                else ['ping', '-n', '1', '-l', str(packet_size), '-w', str(timeout * 1000), host]
            )
            output = subprocess.run(command, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
            # 根据系统决定编码
            encoding = 'utf-8' if sys.platform != 'win32' else 'gbk'
            print(f"Ping {host}：{output.stdout.decode(encoding, errors='ignore').strip() if output.returncode == 0 else output.stderr.decode(encoding, errors='ignore').strip()}")
        except Exception as e:
            print(f"错误: {e}")
        time.sleep(1)

def start_ping():
    """启动 ping 功能"""
    while True:
        user_input = input("""请输入命令（host packet_size count timeout）
               基本示例：
               google.com 64 5 2
               这条命令将对 google.com 发送 5 次包大小为 64 字节的 ping 请求，超时设置为 2 秒。

               自定义参数：
               8.8.8.8 128 10 1
               这条命令将对 8.8.8.8 发送 10 次包大小为 128 字节的 ping 请求，超时设置为 1 秒。
输入 'exit' 退出: """)
        if user_input.lower() == 'exit':
            break
        try:
            host, packet_size, count, timeout = user_input.split()
            packet_size, count, timeout = int(packet_size), int(count), int(timeout)
            # 启动新的线程来执行 ping
            threading.Thread(target=ping, args=(host, packet_size, count, timeout)).start()
        except ValueError:
            print("输入无效。格式: host packet_size count timeout")

# if __name__ == "__main__":
    # start_ping()
