# system_info.py
import platform
import psutil

def log_system_info():
    info = {}
    
    # 操作系统信息
    info['System'] = platform.system()
    info['Version'] = platform.version()
    info['Platform'] = platform.platform()
    
    # 处理器信息
    info['Processor'] = platform.processor()
    
    # 内存信息
    mem = psutil.virtual_memory()
    info['Total Memory'] = f"{mem.total / (1024 ** 3):.2f} GB"
    info['Available Memory'] = f"{mem.available / (1024 ** 3):.2f} GB"
    
    # 显卡信息
    info['Graphics Card'] = "N/A (no GPU detected)"

    # 日志输出
    with open('system_info.log', 'w') as f:
        for key, value in info.items():
            f.write(f"{key}: {value}\n")
    
    print("System information logged to system_info.log.")

def display_log():
    try:
        with open('system_info.log', 'r') as f:
            log_content = f.read()
            print("\nSystem Information Log:\n")
            print(log_content)
    except FileNotFoundError:
        print("Log file not found.")

def windows_info():
    log_system_info()
    
    # 用户输入
    user_input = input("Do you want to display the log? (y/n): ").strip().lower()
    if user_input == 'y':
        display_log()

