# import subprocess

# # 常见用户权限
# PERMISSIONS = {
#     'F': '完全控制',
#     'R': '读取',
#     'W': '写入',
#     'D': '删除',
#     'M': '修改'
# }

# def create_user(username, permissions, path):
#     try:
#         subprocess.run(['net', 'localgroup', username, '/add'], check=True)
#         print(f"用户 '{username}' 创建成功。")
#         set_permissions(path, username, permissions)
#     except subprocess.CalledProcessError as e:
#         print(f"创建用户失败: {e}")

# def set_permissions(path, username, permissions):
#     try:
#         subprocess.run(['icacls', path, '/grant', f'{username}:{permissions}'], check=True)
#         print(f"已赋予 '{username}' 权限: {permissions}。")
#     except subprocess.CalledProcessError as e:
#         print(f"设置权限失败: {e}")

# def list_users():
#     try:
#         output = subprocess.check_output(['net', 'localgroup'], text=True)
#         print("现有用户:")
#         print(output)
#     except subprocess.CalledProcessError as e:
#         print(f"获取用户列表失败: {e}")

# def modify_permissions(path, username, permissions):
#     set_permissions(path, username, permissions)

# def display_permissions():
#     print("可用权限:")
#     for key, value in PERMISSIONS.items():
#         print(f"{key}: {value}")

# def windows_root():
#     while True:
#         action = input("选择操作 (1: 创建用户, 2: 列出用户, 3: 修改权限, 4: 退出): ")
        
#         if action == '1':
#             username = input("输入要创建的用户名: ")
#             path = input("输入需要修改权限的文件夹路径: ")
#             display_permissions()
#             permissions = input("选择权限 (如 F, R, W, D, M): ")
#             create_user(username, permissions, path)
#         elif action == '2':
#             list_users()
#         elif action == '3':
#             path = input("输入文件夹路径: ")
#             username = input("输入用户名: ")
#             display_permissions()
#             permissions = input("选择新的权限 (如 F, R, W, D, M): ")
#             modify_permissions(path, username, permissions)
#         elif action == '4':
#             print("退出程序。")
#             break
#         else:
#             print("无效的选项，请重试。")
import subprocess

# 常见用户权限
PERMISSIONS = {
    'F': '完全控制',
    'R': '读取',
    'W': '写入',
    'D': '删除',
    'M': '修改'
}

def create_user(username, permissions, path):
    try:
        subprocess.run(['net', 'localgroup', username, '/add'], check=True)
        print(f"用户 '{username}' 创建成功。")
        set_permissions(path, username, permissions)
        check_user_permissions(username, path)
    except subprocess.CalledProcessError as e:
        print(f"创建用户失败: {e}")

def set_permissions(path, username, permissions):
    try:
        subprocess.run(['icacls', path, '/grant', f'{username}:{permissions}'], check=True)
        print(f"已赋予 '{username}' 权限: {permissions}。")
    except subprocess.CalledProcessError as e:
        print(f"设置权限失败: {e}")

def check_user_permissions(username, path):
    try:
        output = subprocess.check_output(['icacls', path], text=True)
        if username in output:
            print(f"用户 '{username}' 权限验证成功。")
        else:
            print(f"用户 '{username}' 权限验证失败。")
    except subprocess.CalledProcessError as e:
        print(f"权限验证失败: {e}")

def list_users():
    try:
        output = subprocess.check_output(['net', 'localgroup'], text=True)
        print("现有用户:")
        print(output)
    except subprocess.CalledProcessError as e:
        print(f"获取用户列表失败: {e}")

def modify_permissions(path, username, permissions):
    set_permissions(path, username, permissions)
    check_user_permissions(username, path)

def display_permissions():
    print("可用权限:")
    for key, value in PERMISSIONS.items():
        print(f"{key}: {value}")

def windows_root():
    while True:
        action = input("选择操作 (1: 创建用户, 2: 列出用户, 3: 修改权限, 4: 退出): ")
        
        if action == '1':
            username = input("输入要创建的用户名: ")
            path = input("输入文件夹路径: ")
            display_permissions()
            permissions = input("选择权限 (如 F, R, W, D, M): ")
            create_user(username, permissions, path)
        elif action == '2':
            list_users()
        elif action == '3':
            path = input("输入文件夹路径: ")
            username = input("输入用户名: ")
            display_permissions()
            permissions = input("选择新的权限 (如 F, R, W, D, M): ")
            modify_permissions(path, username, permissions)
        elif action == '4':
            print("退出程序。")
            break
        else:
            print("无效的选项，请重试。")